package java.nio;

import sun.nio.ch.DirectBuffer;

class DirectDoubleBufferRS extends DirectDoubleBufferS implements DirectBuffer
{
    DirectDoubleBufferRS(DirectBuffer directBuffer, int n, int n2, int n3, int n4, int n5) {
        super(directBuffer, n, n2, n3, n4, n5);
    }
    
    @Override
    public DoubleBuffer slice() {
        int position = this.position();
        int limit = this.limit();
        int n = (position <= limit) ? (limit - position) : 0;
        int n2 = position << 3;
        assert n2 >= 0;
        return new DirectDoubleBufferRS(this, -1, 0, n, n, n2);
    }
    
    @Override
    public DoubleBuffer duplicate() {
        return new DirectDoubleBufferRS(this, this.markValue(), this.position(), this.limit(), this.capacity(), 0);
    }
    
    @Override
    public DoubleBuffer asReadOnlyBuffer() {
        return this.duplicate();
    }
    
    @Override
    public DoubleBuffer put(double n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public DoubleBuffer put(int n, double n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public DoubleBuffer put(DoubleBuffer doubleBuffer) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public DoubleBuffer put(double[] array, int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public DoubleBuffer compact() {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public boolean isDirect() {
        return true;
    }
    
    @Override
    public boolean isReadOnly() {
        return true;
    }
    
    @Override
    public ByteOrder order() {
        return (ByteOrder.nativeOrder() == ByteOrder.BIG_ENDIAN) ? ByteOrder.LITTLE_ENDIAN : ByteOrder.BIG_ENDIAN;
    }
}
